module ADDHX1 (A, B, CO, S);
input  A ;
input  B ;
output CO ;
output S ;

wire p0,p;

   no02s01 u0 ( .a(A), .b(B), .o(p0));
   ao12s01 u1 ( .a(p0), .b(A), .c(B), .o(S));
   na02s01 u2 ( .a(A), .b(B), .o(p));
   in01s01 u3 ( .a(p), .o(CO));

endmodule


module ADDFX1 (A, B, CI, CO, S);
input  A ;
input  B ;
input  CI ;
output CO ;
output S ;

wire p0, p1, ab, i0, i1, i2;

   no02s01 u0 ( .a(A), .b(B), .o(p0));
   ao12s01 u1 ( .a(p0), .b(A), .c(B), .o(ab));
   no02s01 u2 ( .a(ab), .b(CI), .o(p1));
   ao12s01 u3 ( .a(p1), .b(ab), .c(CI), .o(S));
   na02s01 u4 ( .a(A), .b(B), .o(i0));
   na02s01 u5 ( .a(B), .b(CI), .o(i1));
   na02s01 u6 ( .a(A), .b(CI), .o(i2));
   na03s01 u7 ( .a(i0), .b(i1), .c(i2), .o(CO));

endmodule


module AND2X1 (A, B, Y);
input  A ;
input  B ;
output Y ;

wire p;

   na02s01 u0 ( .a(A), .b(B), .o(p));
   in01s01 u1 ( .a(p), .o(Y));

endmodule


module TINVX1 (A, OE, Y);
input A ;
input OE ;
output Y ;

wire p;

   na02s01 u0 ( .a(A), .b(OE), .o(Y));
   
endmodule 

module TBUFX1 (A, OE, Y);
input A ;
input OE ;
output Y ;

wire p;

   na02s01 u0 ( .a(A), .b(OE), .o(p));
   in01s01 u1 ( .a(p), .o(Y));
   
endmodule 

module TBUFX2 (A, OE, Y);
input A ;
input OE ;
output Y ;

wire p;

   na02s01 u0 ( .a(A), .b(OE), .o(p));
   in01s01 u1 ( .a(p), .o(Y));
   
endmodule 

module AOI21X1 (A0, A1, B0, Y);
input  A0 ;
input  A1 ;
input  B0 ;
output Y ;

   ao12s01 u0 ( .a(B0), .b(A0), .c(A1), .o(Y));        

endmodule

module AOI22X1 (A0, A1, B0, B1, Y);
input  A0 ;
input  A1 ;
input  B0 ;
input  B1 ;
output Y ;

   ao22s01 u0 ( .a(A0), .b(A1), .c(B0), .d(B1), .o(Y));        

endmodule

module BUFX1 (A, Y);
input  A ;
output Y ;

wire p;

   in01s01 u0 ( .a(A), .o(p));
   in01s01 u1 ( .a(p), .o(Y));

endmodule

module BUFX3 (A, Y);
input  A ;
output Y ;

wire p;

   in01s02 u0 ( .a(A), .o(p));
   in01s08 u1 ( .a(p), .o(Y));

endmodule

module CLKBUFX1 (A, Y);
input  A ;
output Y ;

assign Y = A;

endmodule

module CLKBUFX2 (A, Y);
input  A ;
output Y ;

assign Y = A;

endmodule

module CLKBUFX3 (A, Y);
input  A ;
output Y ;

assign Y = A;

endmodule

module DFFSRX1 (CK, D, RN, SN, Q, QN);
input  CK ;
input  D ;
input  RN ;
input  SN ;
output Q ;
output QN ;

   ms00f80 u0( .ck(CK), .d(D), .o(Q));
   in01s01 u1( .a(Q), .o(QN));

endmodule

module DFFX1 (CK, D, Q, QN);
input  CK ;
input  D ;
output Q ;
output QN ;

   ms00f80 u0( .ck(CK), .d(D), .o(Q));
   in01s01 u1( .a(Q), .o(QN));

endmodule

module TLATX1 (C, D, Q, QN);
input  C ;
input  D ;
output Q ;
output QN ;

   ms00f80 u0( .ck(C), .d(D), .o(Q));
   in01s01 u1( .a(Q), .o(QN));

endmodule 

module INVX1 (A, Y);
input  A ;
output Y ;

   in01s01 u0 ( .a(A), .o(Y));

endmodule

module INVX2 (A, Y);
input  A ;
output Y ;

   in01s02 u0 ( .a(A), .o(Y));

endmodule

module INVX4 (A, Y);
input  A ;
output Y ;

   in01s04 u0 ( .a(A), .o(Y));

endmodule

module INVX8 (A, Y);
input  A ;
output Y ;

   in01s08 u0 ( .a(A), .o(Y));

endmodule

module MX2X1 (A, B, S0, Y);
input  A ;
input  B ;
input  S0 ;
output Y ;

wire sb;
wire da, db;

   in01s01 u0 ( .a(S0), .o(sb));
   na02s01 u1 ( .a(A), .b(sb), .o(da));
   na02s01 u2 ( .a(B), .b(S0), .o(db));
   na02s01 u3 ( .a(da), .b(db), .o(Y));

endmodule

module NAND2X1 (A, B, Y);
input  A ;
input  B ;
output Y ;

   na02s01 u0 ( .a(A), .b(B), .o(Y));   

endmodule

module NAND2X2 (A, B, Y);
input  A ;
input  B ;
output Y ;

   na02s02 u0 ( .a(A), .b(B), .o(Y));   

endmodule

module NAND3X1 (A, B, C, Y);
input  A ;
input  B ;
input  C ;
output Y ;

   na03s01 u0 ( .a(A), .b(B), .c(C), .o(Y));   

endmodule

module NAND4X1 (A, B, C, D, Y);
input  A ;
input  B ;
input  C ;
input  D ;
output Y ;

   na04s01 u0 ( .a(A), .b(B), .c(C), .d(D), .o(Y));   

endmodule

module NOR2X1 (A, B, Y);
input  A ;
input  B ;
output Y ;

   no02s01 u0 ( .a(A), .b(B), .o(Y));   

endmodule

module NOR3X1 (A, B, C, Y);
input  A ;
input  B ;
input  C ;
output Y ;

   no03s01 u0 ( .a(A), .b(B), .c(C), .o(Y));   

endmodule

module NOR4X1 (A, B, C, D, Y);
input  A ;
input  B ;
input  C ;
input  D ;
output Y ;

   no04s01 u0 ( .a(A), .b(B), .c(C), .d(D), .o(Y));   

endmodule

module OAI21X1 (A0, A1, B0, Y);
input  A0 ;
input  A1 ;
input  B0 ;
output Y ;

   oa12s01 u0 ( .a(B0), .b(A0), .c(A1), .o(Y));        

endmodule

module OAI22X1 (A0, A1, B0, B1, Y);
input  A0 ;
input  A1 ;
input  B0 ;
input  B1 ;
output Y ;

   oa22s01 u0 ( .a(A0), .b(A1), .c(B0), .d(B1), .o(Y));       

endmodule

module OAI33X1 (A0, A1, A2, B0, B1, B2, Y);
input  A0 ;
input  A1 ;
input  A2 ;
input  B0 ;
input  B1 ;
input  B2 ;
output Y ;

wire AP, BP;

wire p;

   no03s01 u0 ( .a(A0), .b(A1), .c(A2), .o(AP));
   no03s01 u1 ( .a(B0), .b(B1), .c(B2), .o(BP));
   no02s01 u2 ( .a(AP), .b(BP), .o(p));
   in01s01 u3 ( .a(p), .o(Y));

endmodule

module OR2X1 (A, B, Y);
input  A ;
input  B ;
output Y ;

wire p;

   no02s01 u0 ( .a(A), .b(B), .o(p));
   in01s01 u1 ( .a(p), .o(Y));

endmodule

module OR4X1 (A, B, C, D, Y);
input  A ;
input  B ;
input  C ;
input  D ;
output Y ;

wire p1, p2;

   no02s01 u0 ( .a(A), .b(B), .o(p1));
   no02s01 u1 ( .a(C), .b(D), .o(p2));
   na02s01 u2 ( .a(p1), .b(p2), .o(Y));

endmodule

module SDFFSRX1 (CK, D, RN, SE, SI, SN, Q, QN);
input  CK ;
input  D ;
input  RN ;
input  SE ;
input  SI ;
input  SN ;
output Q ;
output QN ;

   ms00f80 u0( .ck(CK), .d(D), .o(Q));
   in01s01 u1( .a(Q), .o(QN));

endmodule

module XOR2X1 (A, B, Y);
input  A ;
input  B ;
output Y ;

wire p;

   no02s01 u0 ( .a(A), .b(B), .o(p));
   ao12s01 u1 ( .a(p), .b(A), .c(B), .o(Y));


endmodule


